import es, playerlib, services, os, gamethread


info = es.AddonInfo()
info.name = "LooneyChat"
info.version = "0.9beta"
info.author = "Satoon101"
es.ServerVar("looneychat_version",info.version,"looneychat_version").makepublic()

es.mexec('../addons/eventscripts/looneychat/lc_config.cfg')
lc_admin_admin = es.ServerVar('lc_admin_admin')
looney_admin_admin = es.ServerVar('looney_admin_admin')
lc_admin_player = es.ServerVar('lc_admin_player')
looney_admin_player = es.ServerVar('looney_admin_player')
lc_player_admin = es.ServerVar('lc_player_admin')
looney_player_admin = es.ServerVar('looney_player_admin')
lc_alltext = es.ServerVar('lc_alltext')
lc_admin_rounds = es.ServerVar('lc_admin_rounds')
lc_player_rounds = es.ServerVar('lc_player_rounds')
lc_announce_admins = es.ServerVar('lc_announce_admins')

lc_admin_round_count = 0
lc_player_round_count = 0

def load():
    auth = services.use('auth')
    auth.registerCapability('looneychat', auth.ADMIN)
    gamethread.delayed(0, setcommands)

def setcommands():
    if lc_admin_admin == 1:
        es.regsaycmd(looney_admin_admin, 'looneychat/admin_admin_talk', 'Send admin to admin text')
    if lc_admin_player == 1:
        es.regsaycmd(looney_admin_player, 'looneychat/admin_player_talk', 'Send admin to player text')
    if lc_player_admin == 1:
        es.regsaycmd(looney_player_admin, 'looneychat/player_admin_talk', 'Send player to admin text')

def unload():
    if lc_admin_admin == 1:
        es.unregsaycmd(looney_admin_admin)
    if lc_admin_player == 1:
        es.unregsaycmd(looney_admin_player)
    if lc_player_admin == 1:
        es.unregsaycmd(looney_player_admin)

def round_start(ev):
    global lc_admin_round_count, lc_player_round_count
    auth = services.use('auth')
    if lc_admin_rounds > 0 and (lc_admin_player == 1 or lc_admin_admin == 1):
        lc_admin_round_count += 1
        if lc_admin_round_count == lc_admin_rounds:
            lc_admin_round_count = 0
            for admins in playerlib.getPlayerList('#human'):
                admin = int(admins)
                if auth.isUseridAuthorized(admin, 'looneychat'):
                    if lc_admin_admin == 1:
                        es.tell(admin, '#multi', '#green[LooneyChat]#default For Admin to Admin Only Chat, type#lightgreen %s <text>'%looney_admin_admin)
                    if lc_admin_player == 1:
                        es.tell(admin, '#multi', '#green[LooneyChat]#default For Admin to Player Chat, type#lightgreen %s <playername> <text>'%looney_admin_player)
    if lc_player_rounds > 0 and lc_player_admin == 1:
        lc_player_round_count += 1
        if lc_player_round_count == lc_player_rounds:
            lc_player_round_count = 0
            lc_online_admins = []
            lc_non_admins = []
            for non_admins in playerlib.getPlayerList('#human'):
                non_admin = int(non_admins)
                if not auth.isUseridAuthorized(non_admin, 'looneychat'):
                    es.tell(non_admin, '#multi', '#green[LooneyChat]#default To talk directly with admins, type#lightgreen %s <text>'%looney_player_admin)
                    if lc_announce_admins == 1:
                        lc_non_admins.append(non_admin)
                elif lc_announce_admins == 1:
                    lc_online_admins.append(non_admin)
            if lc_announce_admins == 1:
                total_admins = 0
                text = '#green[LooneyChat]#default Online Admins are#lightgreen '
                for lc_online_admin in lc_online_admins:
                    lc_admin_name = es.getplayername(lc_online_admin)
                    if total_admins == 0:
                        text = '%s %s'%(text, lc_admin_name)
                        total_admins = 1
                    else:
                        text = '%s#default,#lightgreen %s'%(text, lc_admin_name)
                if total_admins == 1:
                    for lc_non_admin in lc_non_admins:
                        es.tell(lc_non_admin, '#multi', '%s'%text)

def admin_admin_talk():
    userid = es.getcmduserid()
    words = es.getargc()
    auth = services.use('auth')
    if auth.isUseridAuthorized(userid, 'looneychat'):
        if words > 1:
            name = es.getplayername(userid)
            text = es.getargv(1)
            for word in range(2, words):
                next = es.getargv(word)
                text = '%s %s'%(text, next)
            for admins in playerlib.getPlayerList('#human'):
                admin = int(admins)
                if auth.isUseridAuthorized(admin, 'looneychat') and admin != userid:
                    es.tell(admin, '#multi', '#green[Admin to Admins]#lightgreen %s#default: %s'%(name, text))
        else:
            es.tell(userid, '#multi', '#green[LooneyChat]#default Invalid syntax: #lightgreen%s <text>'%looney_admin_admin)
    else:
        es.tell(userid, '#multi', '#green[LooneyChat]#defaultOnly #lightgreenAdmins#default are allowed to use the command #lightgreen%s'%looney_admin_admin)

def admin_player_talk():
    userid = es.getcmduserid()
    words = es.getargc()
    auth = services.use('auth')
    name = es.getplayername(userid)
    if auth.isUseridAuthorized(userid, 'looneychat'):
        if words > 2:
            playername = es.getargv(1)
            player = es.getuserid(playername)
            if player != 0:
                if es.getplayersteamid(player) != 'BOT':
                    text = es.getargv(2)
                    for word in range(3, words):
                        next = es.getargv(word)
                        text = '%s %s'%(text, next)
                    es.tell(player, '#multi', '#green[Admin to Player]#lightgreen %s#default: %s'%(name, text))
                else:
                    es.tell(userid, '#multi', '#green[LooneyChat]#lightgreen %s#default is a BOT'%playername)
            else:
                es.tell(userid, '#multi', '#green[LooneyChat]#defaultThere is no player by the name #lightgreen%s'%playername)
        else:
            es.tell(userid, '#multi', '#green[LooneyChat]#default Invalid syntax: #lightgreen%s <playername> <text>'%looney_admin_player)
    else:
        es.tell(userid, '#multi', '#green[LooneyChat]#defaultOnly #lightgreenAdmins#default are allowed to use the command #lightgreen%s'%looney_admin_player)

def player_admin_talk():
    userid = es.getcmduserid()
    words = es.getargc()
    auth = services.use('auth')
    if not auth.isUseridAuthorized(userid, 'looneychat'):
        if words > 1:
            text = es.getargv(1)
            for word in range(2, words):
                next = es.getargv(word)
                text = '%s %s'%(text, next)
            for admins in playerlib.getPlayerList('#human'):
                admin = int(admins)
                if auth.isUseridAuthorized(admin, 'looneychat') and admin != userid:
                    es.tell(admin, '#multi', '#green[Player to Admins]#lightgreen %s#default: %s'%(es.getplayername(userid), text))
        else:
            es.tell(userid, '#multi', '#green[LooneyChat]#default Invalid syntax: #lightgreen%s <text>'%looney_player_admin)
    else:
        es.tell(userid, '#multi', '#green[LooneyChat]#default Admins are not allowed to use the command #lightgreen%s'%looney_player_admin)

def es_player_chat(ev):
    auth = services.use('auth')
    if lc_alltext == 1:
        text = ev['text']
        userid = ev['userid']
        teamonly = ev['teamonly']
        team = int(ev['es_userteam'])
        dead = ev['es_userdead']
        name = ev['es_username']
        words = text.split()
        first = words[0]
        if not es.exists('saycommand', first):
            textstart = '#green[LooneyChat]#default *DEAD*#lightgreen %s#default: '%name if dead == '1' else '#green[LooneyChat]#lightgreen %s#default: '%name
            if teamonly == '1':
                for users in playerlib.getPlayerList('#human'):
                    user = int(users)
                    adminteam = es.getplayerteam(user)
                    if auth.isUseridAuthorized(user, 'looneychat') and team != adminteam:
                        es.tell(user, '#multi', '%s %s'%(textstart, text))
                if dead == '1':
                    for users in playerlib.getPlayerList('#human,#alive'):
                        adminteam = es.getplayerteam(users)
                        user = int(users)
                        if auth.isUseridAuthorized(user, 'looneychat') and adminteam == team and userid != user:
                            es.tell(user, '#multi', '%s %s'%(textstart, text))
            elif teamonly == '0' and dead == '1':
                for users in playerlib.getPlayerList('#human,#alive'):
                    user = int(users)
                    if auth.isUseridAuthorized(user, 'looneychat') and userid != user:
                        es.tell(user, '#multi', '%s %s'%(textstart, text))